#include <ilsolver/ilcint.h>

#include <sys/times.h>
#include <limits.h>

#define GetTime(NS,Name,What) \
{                                                        \
  struct tms buffer;                                     \
  clock_t t1, t2;                                        \
  unsigned int t;                                        \
  printf("   %s:\n      [\n",Name);                      \
  for (int i=0; i<NS; i++) {                             \
    t1 = times(&buffer);                                 \
    printf(" huhu\n");                                   \
    What;                                                \
    printf(" gaga\n");                                   \
    t2 = times(&buffer);                                 \
    t = (unsigned int) ((t2-t1)*1000.0/(double)CLK_TCK); \
    printf("      d(wall:%d)\n",t);                      \
  }                                                      \
  printf("    ]\n");                                     \
}

// extern void alpha(int);

// extern void magic(int);

// extern void queens(IlcInt,int,int);

// extern void squeens(IlcInt,int,int);

// extern void knights(IlcInt);

extern void money();

int main(int argc, char** argv){

  int ns = (argc > 1) ? atoi(argv[1]) : 1;
  
  printf("ilog(\n");

  //  GetTime(ns,"ms500", magic(500));

  //  GetTime(ns,"alphaOne", alpha(0));

  //  GetTime(ns,"alphaAll", alpha(1));

  //  GetTime(ns,"queensNaive10", queens(10,1,1));

  //  GetTime(ns,"queensNaive100", queens(100,0,0));

  //  GetTime(ns,"queensSmart10", squeens(10,1,1));

  //  GetTime(ns,"queensSmart100", squeens(100,0,0));

  //  GetTime(ns,"knights18", knights(18));

  GetTime(ns,"money",money());

  printf("   )\n");

  return 0;
}

